#!/bin/bash 
echo Arrangement: GarageDoor

echo 
rm -f OpenSensor.lisp OpenSensorllfsm.lisp 

echo "(setf (readtable-case *readtable*) :preserve)" >>OpenSensor.lisp

echo  "(SETQ OS_Test_Door " >>OpenSensor.lisp

echo "("  LIST "; the sections"  >>OpenSensor.lisp

echo "("  LIST ";" the ONENTRY  >>OpenSensor.lisp

echo ") ;"  endONENTRY >>OpenSensor.lisp

echo "("  LIST ";" the Dummy ONEXIT >>OpenSensor.lisp

echo "(QUOTE ()) )"  >>OpenSensor.lisp

echo ") ;endSections " >>OpenSensor.lisp

echo ") ;endSETQ " >>OpenSensor.lisp
 
echo  "(SETQ OS_Door_Reached_Open " >>OpenSensor.lisp

echo "("  LIST "; the sections"  >>OpenSensor.lisp

echo "("  LIST ";" the ONENTRY  >>OpenSensor.lisp

 echo " ' (SETMDV  OpenDoorSensorStatus  1 )  ">>OpenSensor.lisp

echo ") ;"  endONENTRY >>OpenSensor.lisp

echo "("  LIST ";" the Dummy ONEXIT >>OpenSensor.lisp

echo "(QUOTE ()) )"  >>OpenSensor.lisp

echo ") ;endSections " >>OpenSensor.lisp

echo ") ;endSETQ " >>OpenSensor.lisp
 
echo  "(SETQ OS_Door_Away_From_Open " >>OpenSensor.lisp

echo "("  LIST "; the sections"  >>OpenSensor.lisp

echo "("  LIST ";" the ONENTRY  >>OpenSensor.lisp

 echo " ' (SETMDV  OpenDoorSensorStatus  0 )  ">>OpenSensor.lisp

echo ") ;"  endONENTRY >>OpenSensor.lisp

echo "("  LIST ";" the Dummy ONEXIT >>OpenSensor.lisp

echo "(QUOTE ()) )"  >>OpenSensor.lisp

echo ") ;endSections " >>OpenSensor.lisp

echo ") ;endSETQ " >>OpenSensor.lisp
  
echo "(SETQ OpenSensor (LIST   (LIST OS_Test_Door OS_Door_Reached_Open OS_Door_Away_From_Open )   (LIST (LIST  1  '  (NOT  DoorPressesOpenDoorSensor ) 2 )(LIST  2  '  DoorPressesOpenDoorSensor  1 )(LIST   0   '  DoorPressesOpenDoorSensor  1 )(LIST   0   '  (NOT  DoorPressesOpenDoorSensor ) 2 ))))" >>OpenSensor.lisp

echo "(PRINT OpenSensor)" >>OpenSensor.lisp

echo 
rm -f ClosedSensor.lisp ClosedSensorllfsm.lisp 

echo "(setf (readtable-case *readtable*) :preserve)" >>ClosedSensor.lisp

echo  "(SETQ CS_Test_Door " >>ClosedSensor.lisp

echo "("  LIST "; the sections"  >>ClosedSensor.lisp

echo "("  LIST ";" the Dummy ONEXIT >>ClosedSensor.lisp

echo "(QUOTE ()) )"  >>ClosedSensor.lisp

echo ") ;endSections " >>ClosedSensor.lisp

echo ") ;endSETQ " >>ClosedSensor.lisp
 
echo  "(SETQ CS_Door_Reached_Closed " >>ClosedSensor.lisp

echo "("  LIST "; the sections"  >>ClosedSensor.lisp

echo "("  LIST ";" the ONENTRY  >>ClosedSensor.lisp

 echo " ' (SETMDV  ClosedDoorSensorStatus  1 )  ">>ClosedSensor.lisp

echo ") ;"  endONENTRY >>ClosedSensor.lisp

echo "("  LIST ";" the Dummy ONEXIT >>ClosedSensor.lisp

echo "(QUOTE ()) )"  >>ClosedSensor.lisp

echo ") ;endSections " >>ClosedSensor.lisp

echo ") ;endSETQ " >>ClosedSensor.lisp
 
echo  "(SETQ CS_Door_Away_From_Closed " >>ClosedSensor.lisp

echo "("  LIST "; the sections"  >>ClosedSensor.lisp

echo "("  LIST ";" the ONEXIT  >>ClosedSensor.lisp

 echo " ' (SETMDV  ClosedDoorSensorStatus  0 )  ">>ClosedSensor.lisp

echo ") ;"  endONEXIT >>ClosedSensor.lisp

echo ") ;endSections " >>ClosedSensor.lisp

echo ") ;endSETQ " >>ClosedSensor.lisp
  
echo "(SETQ ClosedSensor (LIST   (LIST CS_Test_Door CS_Door_Reached_Closed CS_Door_Away_From_Closed )   (LIST (LIST  2  '  DoorPressesClosedDoorSensor  1 )(LIST  1  '  (NOT  DoorPressesClosedDoorSensor ) 2 )(LIST   0   '  (NOT  DoorPressesClosedDoorSensor ) 2 )(LIST   0   '  DoorPressesClosedDoorSensor  1 ))))" >>ClosedSensor.lisp

echo "(PRINT ClosedSensor)" >>ClosedSensor.lisp

echo 
rm -f DoorController.lisp DoorControllerllfsm.lisp 

echo "(setf (readtable-case *readtable*) :preserve)" >>DoorController.lisp

echo  "(SETQ Secure_Motor_Has_Stopped " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the ONENTRY  >>DoorController.lisp

 echo " ' (SETMDV  MotorControlSignal 0)  ">>DoorController.lisp

echo ") ;"  endONENTRY >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Opening_Pressed " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the ONENTRY  >>DoorController.lisp

 echo " ' (SETMDV  MotorControlSignal 1)  ">>DoorController.lisp

 echo " ' (SETMDV  history  MotorControlSignal )  ">>DoorController.lisp

echo ") ;"  endONENTRY >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Pause_Openning_Pressed " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the ONENTRY  >>DoorController.lisp

 echo " ' (SETMDV  MotorControlSignal 0)  ">>DoorController.lisp

 echo " ' (SETMDV  history  MotorControlSignal )  ">>DoorController.lisp

echo ") ;"  endONENTRY >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Closing_Pressed " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the ONENTRY  >>DoorController.lisp

 echo " ' (SETMDV  MotorControlSignal 2)  ">>DoorController.lisp

 echo " ' (SETMDV  history  MotorControlSignal )  ">>DoorController.lisp

echo ") ;"  endONENTRY >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Door_Opened " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the ONENTRY  >>DoorController.lisp

 echo " ' (SETMDV  MotorControlSignal 0)  ">>DoorController.lisp

echo ") ;"  endONENTRY >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Opening_Released " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Closing_Released " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Pause_Released " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Pause_Closing_Pressed " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the ONENTRY  >>DoorController.lisp

 echo " ' (SETMDV  MotorControlSignal 0)  ">>DoorController.lisp

 echo " ' (SETMDV  history  MotorControlSignal )  ">>DoorController.lisp

echo ") ;"  endONENTRY >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Locked " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the ONENTRY  >>DoorController.lisp

 echo " ' (SETMDV  MotorControlSignal 0)  ">>DoorController.lisp

echo ") ;"  endONENTRY >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Test_Door_Status " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the Dummy ONEXIT >>DoorController.lisp

echo "(QUOTE ()) )"  >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
 
echo  "(SETQ Door_Closed " >>DoorController.lisp

echo "("  LIST "; the sections"  >>DoorController.lisp

echo "("  LIST ";" the ONEXIT  >>DoorController.lisp

 echo " ' (SETMDV  MotorControlSignal 0)  ">>DoorController.lisp

echo ") ;"  endONEXIT >>DoorController.lisp

echo ") ;endSections " >>DoorController.lisp

echo ") ;endSETQ " >>DoorController.lisp
  
echo "(SETQ DoorController (LIST   (LIST Secure_Motor_Has_Stopped Opening_Pressed Pause_Openning_Pressed Closing_Pressed Door_Opened Opening_Released Closing_Released Pause_Released Pause_Closing_Pressed Locked Test_Door_Status Door_Closed )   (LIST (LIST  11  '  (EQUAL  RemoteControlStatus  1) 1 )(LIST  1  '  EmergencyPressed  9 )(LIST  3  '  EmergencyPressed  9 )(LIST  9  '  (AND  (NOT  EmergencyPressed ) (AND  (AFTER   3 )  (AND  (EQUAL  history  1) KeyUnlock ))) 1 )(LIST  5  '  EmergencyPressed  9 )(LIST  6  '  EmergencyPressed  9 )(LIST  9  '  (AND  (NOT  EmergencyPressed ) (AND  (AFTER   1 )  (AND  (EQUAL  history  2) KeyUnlock ))) 3 )(LIST  2  '  EmergencyPressed  9 )(LIST  7  '  EmergencyPressed  9 )(LIST  8  '  EmergencyPressed  9 )(LIST  9  '  (AND  (NOT  EmergencyPressed ) (AND  (AFTER   2 )  (AND  (EQUAL  history  0) KeyUnlock ))) 7 )(LIST  4  '  (EQUAL  RemoteControlStatus  2) 3 )(LIST  1  '  OpenDoorSensorStatus  4 )(LIST   0   '  (AFTER   1 )  10 )(LIST  1  '  (EQUAL  RemoteControlStatus  0) 5 )(LIST  10  '  ClosedDoorSensorStatus  11 )(LIST  10  '  OpenDoorSensorStatus  4 )(LIST  3  '  ClosedDoorSensorStatus  11 )(LIST  3  '  (EQUAL  RemoteControlStatus  0) 6 )(LIST  6  '  (EQUAL  RemoteControlStatus  2) 8 )(LIST  6  '  ClosedDoorSensorStatus  11 )(LIST  5  '  (EQUAL  RemoteControlStatus  1) 2 )(LIST  5  '  OpenDoorSensorStatus  4 )(LIST  8  '  (EQUAL  RemoteControlStatus  0) 7 )(LIST  7  '  (EQUAL  RemoteControlStatus  1) 1 )(LIST  7  '  (EQUAL  RemoteControlStatus  2) 3 )(LIST  2  '  (EQUAL  RemoteControlStatus  0) 7 ))))" >>DoorController.lisp

echo "(PRINT DoorController)" >>DoorController.lisp

echo 
rm -f RemoteControl.lisp RemoteControlllfsm.lisp 

echo "(setf (readtable-case *readtable*) :preserve)" >>RemoteControl.lisp

echo  "(SETQ Idle " >>RemoteControl.lisp

echo "("  LIST "; the sections"  >>RemoteControl.lisp

echo "("  LIST ";" the ONENTRY  >>RemoteControl.lisp

 echo " ' (SETMDV  RemoteControlStatus 0)  ">>RemoteControl.lisp

echo ") ;"  endONENTRY >>RemoteControl.lisp

echo "("  LIST ";" the Dummy ONEXIT >>RemoteControl.lisp

echo "(QUOTE ()) )"  >>RemoteControl.lisp

echo ") ;endSections " >>RemoteControl.lisp

echo ") ;endSETQ " >>RemoteControl.lisp
 
echo  "(SETQ SignalOpen " >>RemoteControl.lisp

echo "("  LIST "; the sections"  >>RemoteControl.lisp

echo "("  LIST ";" the ONENTRY  >>RemoteControl.lisp

 echo " ' (SETMDV  RemoteControlStatus 1)  ">>RemoteControl.lisp

echo ") ;"  endONENTRY >>RemoteControl.lisp

echo "("  LIST ";" the Dummy ONEXIT >>RemoteControl.lisp

echo "(QUOTE ()) )"  >>RemoteControl.lisp

echo ") ;endSections " >>RemoteControl.lisp

echo ") ;endSETQ " >>RemoteControl.lisp
 
echo  "(SETQ SignalClose " >>RemoteControl.lisp

echo "("  LIST "; the sections"  >>RemoteControl.lisp

echo "("  LIST ";" the ONENTRY  >>RemoteControl.lisp

 echo " ' (SETMDV  RemoteControlStatus 2)  ">>RemoteControl.lisp

echo ") ;"  endONENTRY >>RemoteControl.lisp

echo "("  LIST ";" the Dummy ONEXIT >>RemoteControl.lisp

echo "(QUOTE ()) )"  >>RemoteControl.lisp

echo ") ;endSections " >>RemoteControl.lisp

echo ") ;endSETQ " >>RemoteControl.lisp
  
echo "(SETQ RemoteControl (LIST   (LIST Idle SignalOpen SignalClose )   (LIST (LIST   0   '  (EQUAL  RemoteControlSignal  1) 1 )(LIST  1  '  (EQUAL  RemoteControlSignal  0)  0  )(LIST  2  '  (EQUAL  RemoteControlSignal  0)  0  )(LIST   0   '  (EQUAL  RemoteControlSignal  2) 2 ))))" >>RemoteControl.lisp

echo "(PRINT RemoteControl)" >>RemoteControl.lisp

echo 
rm -f Motor.lisp Motorllfsm.lisp 

echo "(setf (readtable-case *readtable*) :preserve)" >>Motor.lisp

echo  "(SETQ Stopped " >>Motor.lisp

echo "("  LIST "; the sections"  >>Motor.lisp

echo "("  LIST ";" the ONENTRY  >>Motor.lisp

 echo " ' (SETMDV  MotorStatus 0)  ">>Motor.lisp

echo ") ;"  endONENTRY >>Motor.lisp

echo "("  LIST ";" the Dummy ONEXIT >>Motor.lisp

echo "(QUOTE ()) )"  >>Motor.lisp

echo ") ;endSections " >>Motor.lisp

echo ") ;endSETQ " >>Motor.lisp
 
echo  "(SETQ Forwards " >>Motor.lisp

echo "("  LIST "; the sections"  >>Motor.lisp

echo "("  LIST ";" the ONENTRY  >>Motor.lisp

 echo " ' (SETMDV  MotorStatus 1)  ">>Motor.lisp

echo ") ;"  endONENTRY >>Motor.lisp

echo "("  LIST ";" the Dummy ONEXIT >>Motor.lisp

echo "(QUOTE ()) )"  >>Motor.lisp

echo ") ;endSections " >>Motor.lisp

echo ") ;endSETQ " >>Motor.lisp
 
echo  "(SETQ Backwards " >>Motor.lisp

echo "("  LIST "; the sections"  >>Motor.lisp

echo "("  LIST ";" the ONENTRY  >>Motor.lisp

 echo " ' (SETMDV  MotorStatus 2)  ">>Motor.lisp

echo ") ;"  endONENTRY >>Motor.lisp

echo "("  LIST ";" the Dummy ONEXIT >>Motor.lisp

echo "(QUOTE ()) )"  >>Motor.lisp

echo ") ;endSections " >>Motor.lisp

echo ") ;endSETQ " >>Motor.lisp
  
echo "(SETQ Motor (LIST   (LIST Stopped Forwards Backwards )   (LIST (LIST   0   '  (EQUAL  MotorControlSignal  1) 1 )(LIST  1  '  (EQUAL  MotorControlSignal  0)  0  )(LIST   0   '  (EQUAL  MotorControlSignal  2) 2 )(LIST  2  '  (EQUAL  MotorControlSignal  0)  0  ))))" >>Motor.lisp

echo "(PRINT Motor)" >>Motor.lisp
clisp OpenSensor.lisp > OpenSensorllfsm.lisp
clisp ClosedSensor.lisp > ClosedSensorllfsm.lisp
clisp DoorController.lisp > DoorControllerllfsm.lisp
clisp RemoteControl.lisp > RemoteControlllfsm.lisp
clisp Motor.lisp > Motorllfsm.lisp
clisp -C -m 10000MB  state-example.lisp  -m OpenSensorllfsm.lisp -m ClosedSensorllfsm.lisp -m DoorControllerllfsm.lisp -m RemoteControlllfsm.lisp -m Motorllfsm.lisp   -s DoorPressesOpenDoorSensor -s DoorPressesClosedDoorSensor -s EmergencyPressed -s KeyUnlock  -w OpenDoorSensorStatus -w ClosedDoorSensorStatus -s RemoteControlSignal  -e MotorStatus  -w MotorControlSignal -w RemoteControlStatus
