/**
 */
package newGITmetamodelwithtypes.impl;

import java.util.Collection;

import newGITmetamodelwithtypes.Arrangement;
import newGITmetamodelwithtypes.ListOfBooleanVariables;
import newGITmetamodelwithtypes.ListOfGlobalIntegerConstants;
import newGITmetamodelwithtypes.ListOfVariables;
import newGITmetamodelwithtypes.NewGITmetamodelwithtypesPackage;
import newGITmetamodelwithtypes.StateMachine;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Arrangement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link newGITmetamodelwithtypes.impl.ArrangementImpl#getArrangementName <em>Arrangement Name</em>}</li>
 *   <li>{@link newGITmetamodelwithtypes.impl.ArrangementImpl#getStateMachine <em>State Machine</em>}</li>
 *   <li>{@link newGITmetamodelwithtypes.impl.ArrangementImpl#getSensorVariables <em>Sensor Variables</em>}</li>
 *   <li>{@link newGITmetamodelwithtypes.impl.ArrangementImpl#getBooleanSensorVariables <em>Boolean Sensor Variables</em>}</li>
 *   <li>{@link newGITmetamodelwithtypes.impl.ArrangementImpl#getEffectorVariables <em>Effector Variables</em>}</li>
 *   <li>{@link newGITmetamodelwithtypes.impl.ArrangementImpl#getBooleanEffectorVariables <em>Boolean Effector Variables</em>}</li>
 *   <li>{@link newGITmetamodelwithtypes.impl.ArrangementImpl#getWhiteboardVariables <em>Whiteboard Variables</em>}</li>
 *   <li>{@link newGITmetamodelwithtypes.impl.ArrangementImpl#getBooleanWhiteboardVariables <em>Boolean Whiteboard Variables</em>}</li>
 *   <li>{@link newGITmetamodelwithtypes.impl.ArrangementImpl#getIntegerConstantDefinitions <em>Integer Constant Definitions</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ArrangementImpl extends MinimalEObjectImpl.Container implements Arrangement {
	/**
	 * The default value of the '{@link #getArrangementName() <em>Arrangement Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArrangementName()
	 * @generated
	 * @ordered
	 */
	protected static final String ARRANGEMENT_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getArrangementName() <em>Arrangement Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArrangementName()
	 * @generated
	 * @ordered
	 */
	protected String arrangementName = ARRANGEMENT_NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStateMachine() <em>State Machine</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStateMachine()
	 * @generated
	 * @ordered
	 */
	protected EList<StateMachine> stateMachine;

	/**
	 * The cached value of the '{@link #getSensorVariables() <em>Sensor Variables</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSensorVariables()
	 * @generated
	 * @ordered
	 */
	protected ListOfVariables sensorVariables;

	/**
	 * The cached value of the '{@link #getBooleanSensorVariables() <em>Boolean Sensor Variables</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBooleanSensorVariables()
	 * @generated
	 * @ordered
	 */
	protected ListOfBooleanVariables booleanSensorVariables;

	/**
	 * The cached value of the '{@link #getEffectorVariables() <em>Effector Variables</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEffectorVariables()
	 * @generated
	 * @ordered
	 */
	protected ListOfVariables effectorVariables;

	/**
	 * The cached value of the '{@link #getBooleanEffectorVariables() <em>Boolean Effector Variables</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBooleanEffectorVariables()
	 * @generated
	 * @ordered
	 */
	protected ListOfBooleanVariables booleanEffectorVariables;

	/**
	 * The cached value of the '{@link #getWhiteboardVariables() <em>Whiteboard Variables</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWhiteboardVariables()
	 * @generated
	 * @ordered
	 */
	protected ListOfVariables whiteboardVariables;

	/**
	 * The cached value of the '{@link #getBooleanWhiteboardVariables() <em>Boolean Whiteboard Variables</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBooleanWhiteboardVariables()
	 * @generated
	 * @ordered
	 */
	protected ListOfBooleanVariables booleanWhiteboardVariables;

	/**
	 * The cached value of the '{@link #getIntegerConstantDefinitions() <em>Integer Constant Definitions</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntegerConstantDefinitions()
	 * @generated
	 * @ordered
	 */
	protected ListOfGlobalIntegerConstants integerConstantDefinitions;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ArrangementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return NewGITmetamodelwithtypesPackage.Literals.ARRANGEMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getArrangementName() {
		return arrangementName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setArrangementName(String newArrangementName) {
		String oldArrangementName = arrangementName;
		arrangementName = newArrangementName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__ARRANGEMENT_NAME, oldArrangementName,
					arrangementName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<StateMachine> getStateMachine() {
		if (stateMachine == null) {
			stateMachine = new EObjectContainmentEList<StateMachine>(StateMachine.class, this,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__STATE_MACHINE);
		}
		return stateMachine;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfVariables getSensorVariables() {
		return sensorVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSensorVariables(ListOfVariables newSensorVariables, NotificationChain msgs) {
		ListOfVariables oldSensorVariables = sensorVariables;
		sensorVariables = newSensorVariables;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__SENSOR_VARIABLES, oldSensorVariables,
					newSensorVariables);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSensorVariables(ListOfVariables newSensorVariables) {
		if (newSensorVariables != sensorVariables) {
			NotificationChain msgs = null;
			if (sensorVariables != null)
				msgs = ((InternalEObject) sensorVariables).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesPackage.ARRANGEMENT__SENSOR_VARIABLES, null,
						msgs);
			if (newSensorVariables != null)
				msgs = ((InternalEObject) newSensorVariables).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesPackage.ARRANGEMENT__SENSOR_VARIABLES, null,
						msgs);
			msgs = basicSetSensorVariables(newSensorVariables, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__SENSOR_VARIABLES, newSensorVariables,
					newSensorVariables));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfBooleanVariables getBooleanSensorVariables() {
		return booleanSensorVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBooleanSensorVariables(ListOfBooleanVariables newBooleanSensorVariables,
			NotificationChain msgs) {
		ListOfBooleanVariables oldBooleanSensorVariables = booleanSensorVariables;
		booleanSensorVariables = newBooleanSensorVariables;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_SENSOR_VARIABLES, oldBooleanSensorVariables,
					newBooleanSensorVariables);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBooleanSensorVariables(ListOfBooleanVariables newBooleanSensorVariables) {
		if (newBooleanSensorVariables != booleanSensorVariables) {
			NotificationChain msgs = null;
			if (booleanSensorVariables != null)
				msgs = ((InternalEObject) booleanSensorVariables).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_SENSOR_VARIABLES,
						null, msgs);
			if (newBooleanSensorVariables != null)
				msgs = ((InternalEObject) newBooleanSensorVariables).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_SENSOR_VARIABLES,
						null, msgs);
			msgs = basicSetBooleanSensorVariables(newBooleanSensorVariables, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_SENSOR_VARIABLES, newBooleanSensorVariables,
					newBooleanSensorVariables));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfVariables getEffectorVariables() {
		return effectorVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEffectorVariables(ListOfVariables newEffectorVariables, NotificationChain msgs) {
		ListOfVariables oldEffectorVariables = effectorVariables;
		effectorVariables = newEffectorVariables;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__EFFECTOR_VARIABLES, oldEffectorVariables,
					newEffectorVariables);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEffectorVariables(ListOfVariables newEffectorVariables) {
		if (newEffectorVariables != effectorVariables) {
			NotificationChain msgs = null;
			if (effectorVariables != null)
				msgs = ((InternalEObject) effectorVariables).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesPackage.ARRANGEMENT__EFFECTOR_VARIABLES, null,
						msgs);
			if (newEffectorVariables != null)
				msgs = ((InternalEObject) newEffectorVariables).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesPackage.ARRANGEMENT__EFFECTOR_VARIABLES, null,
						msgs);
			msgs = basicSetEffectorVariables(newEffectorVariables, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__EFFECTOR_VARIABLES, newEffectorVariables,
					newEffectorVariables));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfBooleanVariables getBooleanEffectorVariables() {
		return booleanEffectorVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBooleanEffectorVariables(ListOfBooleanVariables newBooleanEffectorVariables,
			NotificationChain msgs) {
		ListOfBooleanVariables oldBooleanEffectorVariables = booleanEffectorVariables;
		booleanEffectorVariables = newBooleanEffectorVariables;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_EFFECTOR_VARIABLES,
					oldBooleanEffectorVariables, newBooleanEffectorVariables);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBooleanEffectorVariables(ListOfBooleanVariables newBooleanEffectorVariables) {
		if (newBooleanEffectorVariables != booleanEffectorVariables) {
			NotificationChain msgs = null;
			if (booleanEffectorVariables != null)
				msgs = ((InternalEObject) booleanEffectorVariables).eInverseRemove(this, EOPPOSITE_FEATURE_BASE
						- NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_EFFECTOR_VARIABLES, null, msgs);
			if (newBooleanEffectorVariables != null)
				msgs = ((InternalEObject) newBooleanEffectorVariables).eInverseAdd(this, EOPPOSITE_FEATURE_BASE
						- NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_EFFECTOR_VARIABLES, null, msgs);
			msgs = basicSetBooleanEffectorVariables(newBooleanEffectorVariables, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_EFFECTOR_VARIABLES,
					newBooleanEffectorVariables, newBooleanEffectorVariables));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfVariables getWhiteboardVariables() {
		return whiteboardVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetWhiteboardVariables(ListOfVariables newWhiteboardVariables,
			NotificationChain msgs) {
		ListOfVariables oldWhiteboardVariables = whiteboardVariables;
		whiteboardVariables = newWhiteboardVariables;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__WHITEBOARD_VARIABLES, oldWhiteboardVariables,
					newWhiteboardVariables);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setWhiteboardVariables(ListOfVariables newWhiteboardVariables) {
		if (newWhiteboardVariables != whiteboardVariables) {
			NotificationChain msgs = null;
			if (whiteboardVariables != null)
				msgs = ((InternalEObject) whiteboardVariables).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesPackage.ARRANGEMENT__WHITEBOARD_VARIABLES,
						null, msgs);
			if (newWhiteboardVariables != null)
				msgs = ((InternalEObject) newWhiteboardVariables).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesPackage.ARRANGEMENT__WHITEBOARD_VARIABLES,
						null, msgs);
			msgs = basicSetWhiteboardVariables(newWhiteboardVariables, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__WHITEBOARD_VARIABLES, newWhiteboardVariables,
					newWhiteboardVariables));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfBooleanVariables getBooleanWhiteboardVariables() {
		return booleanWhiteboardVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBooleanWhiteboardVariables(ListOfBooleanVariables newBooleanWhiteboardVariables,
			NotificationChain msgs) {
		ListOfBooleanVariables oldBooleanWhiteboardVariables = booleanWhiteboardVariables;
		booleanWhiteboardVariables = newBooleanWhiteboardVariables;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_WHITEBOARD_VARIABLES,
					oldBooleanWhiteboardVariables, newBooleanWhiteboardVariables);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBooleanWhiteboardVariables(ListOfBooleanVariables newBooleanWhiteboardVariables) {
		if (newBooleanWhiteboardVariables != booleanWhiteboardVariables) {
			NotificationChain msgs = null;
			if (booleanWhiteboardVariables != null)
				msgs = ((InternalEObject) booleanWhiteboardVariables).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE
								- NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_WHITEBOARD_VARIABLES,
						null, msgs);
			if (newBooleanWhiteboardVariables != null)
				msgs = ((InternalEObject) newBooleanWhiteboardVariables).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE
								- NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_WHITEBOARD_VARIABLES,
						null, msgs);
			msgs = basicSetBooleanWhiteboardVariables(newBooleanWhiteboardVariables, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_WHITEBOARD_VARIABLES,
					newBooleanWhiteboardVariables, newBooleanWhiteboardVariables));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfGlobalIntegerConstants getIntegerConstantDefinitions() {
		return integerConstantDefinitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetIntegerConstantDefinitions(
			ListOfGlobalIntegerConstants newIntegerConstantDefinitions, NotificationChain msgs) {
		ListOfGlobalIntegerConstants oldIntegerConstantDefinitions = integerConstantDefinitions;
		integerConstantDefinitions = newIntegerConstantDefinitions;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__INTEGER_CONSTANT_DEFINITIONS,
					oldIntegerConstantDefinitions, newIntegerConstantDefinitions);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setIntegerConstantDefinitions(ListOfGlobalIntegerConstants newIntegerConstantDefinitions) {
		if (newIntegerConstantDefinitions != integerConstantDefinitions) {
			NotificationChain msgs = null;
			if (integerConstantDefinitions != null)
				msgs = ((InternalEObject) integerConstantDefinitions).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE
								- NewGITmetamodelwithtypesPackage.ARRANGEMENT__INTEGER_CONSTANT_DEFINITIONS,
						null, msgs);
			if (newIntegerConstantDefinitions != null)
				msgs = ((InternalEObject) newIntegerConstantDefinitions).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE
								- NewGITmetamodelwithtypesPackage.ARRANGEMENT__INTEGER_CONSTANT_DEFINITIONS,
						null, msgs);
			msgs = basicSetIntegerConstantDefinitions(newIntegerConstantDefinitions, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					NewGITmetamodelwithtypesPackage.ARRANGEMENT__INTEGER_CONSTANT_DEFINITIONS,
					newIntegerConstantDefinitions, newIntegerConstantDefinitions));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__STATE_MACHINE:
			return ((InternalEList<?>) getStateMachine()).basicRemove(otherEnd, msgs);
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__SENSOR_VARIABLES:
			return basicSetSensorVariables(null, msgs);
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_SENSOR_VARIABLES:
			return basicSetBooleanSensorVariables(null, msgs);
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__EFFECTOR_VARIABLES:
			return basicSetEffectorVariables(null, msgs);
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_EFFECTOR_VARIABLES:
			return basicSetBooleanEffectorVariables(null, msgs);
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__WHITEBOARD_VARIABLES:
			return basicSetWhiteboardVariables(null, msgs);
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_WHITEBOARD_VARIABLES:
			return basicSetBooleanWhiteboardVariables(null, msgs);
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__INTEGER_CONSTANT_DEFINITIONS:
			return basicSetIntegerConstantDefinitions(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__ARRANGEMENT_NAME:
			return getArrangementName();
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__STATE_MACHINE:
			return getStateMachine();
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__SENSOR_VARIABLES:
			return getSensorVariables();
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_SENSOR_VARIABLES:
			return getBooleanSensorVariables();
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__EFFECTOR_VARIABLES:
			return getEffectorVariables();
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_EFFECTOR_VARIABLES:
			return getBooleanEffectorVariables();
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__WHITEBOARD_VARIABLES:
			return getWhiteboardVariables();
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_WHITEBOARD_VARIABLES:
			return getBooleanWhiteboardVariables();
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__INTEGER_CONSTANT_DEFINITIONS:
			return getIntegerConstantDefinitions();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__ARRANGEMENT_NAME:
			setArrangementName((String) newValue);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__STATE_MACHINE:
			getStateMachine().clear();
			getStateMachine().addAll((Collection<? extends StateMachine>) newValue);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__SENSOR_VARIABLES:
			setSensorVariables((ListOfVariables) newValue);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_SENSOR_VARIABLES:
			setBooleanSensorVariables((ListOfBooleanVariables) newValue);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__EFFECTOR_VARIABLES:
			setEffectorVariables((ListOfVariables) newValue);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_EFFECTOR_VARIABLES:
			setBooleanEffectorVariables((ListOfBooleanVariables) newValue);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__WHITEBOARD_VARIABLES:
			setWhiteboardVariables((ListOfVariables) newValue);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_WHITEBOARD_VARIABLES:
			setBooleanWhiteboardVariables((ListOfBooleanVariables) newValue);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__INTEGER_CONSTANT_DEFINITIONS:
			setIntegerConstantDefinitions((ListOfGlobalIntegerConstants) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__ARRANGEMENT_NAME:
			setArrangementName(ARRANGEMENT_NAME_EDEFAULT);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__STATE_MACHINE:
			getStateMachine().clear();
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__SENSOR_VARIABLES:
			setSensorVariables((ListOfVariables) null);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_SENSOR_VARIABLES:
			setBooleanSensorVariables((ListOfBooleanVariables) null);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__EFFECTOR_VARIABLES:
			setEffectorVariables((ListOfVariables) null);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_EFFECTOR_VARIABLES:
			setBooleanEffectorVariables((ListOfBooleanVariables) null);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__WHITEBOARD_VARIABLES:
			setWhiteboardVariables((ListOfVariables) null);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_WHITEBOARD_VARIABLES:
			setBooleanWhiteboardVariables((ListOfBooleanVariables) null);
			return;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__INTEGER_CONSTANT_DEFINITIONS:
			setIntegerConstantDefinitions((ListOfGlobalIntegerConstants) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__ARRANGEMENT_NAME:
			return ARRANGEMENT_NAME_EDEFAULT == null ? arrangementName != null
					: !ARRANGEMENT_NAME_EDEFAULT.equals(arrangementName);
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__STATE_MACHINE:
			return stateMachine != null && !stateMachine.isEmpty();
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__SENSOR_VARIABLES:
			return sensorVariables != null;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_SENSOR_VARIABLES:
			return booleanSensorVariables != null;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__EFFECTOR_VARIABLES:
			return effectorVariables != null;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_EFFECTOR_VARIABLES:
			return booleanEffectorVariables != null;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__WHITEBOARD_VARIABLES:
			return whiteboardVariables != null;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__BOOLEAN_WHITEBOARD_VARIABLES:
			return booleanWhiteboardVariables != null;
		case NewGITmetamodelwithtypesPackage.ARRANGEMENT__INTEGER_CONSTANT_DEFINITIONS:
			return integerConstantDefinitions != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (arrangementName: ");
		result.append(arrangementName);
		result.append(')');
		return result.toString();
	}

} //ArrangementImpl
