/**
 */
package newGITmetamodelwithtypesnosections.impl;

import java.util.Collection;

import newGITmetamodelwithtypesnosections.InitialState;
import newGITmetamodelwithtypesnosections.ListOfBooleanVariables;
import newGITmetamodelwithtypesnosections.ListOfClonedHelpingStates;
import newGITmetamodelwithtypesnosections.ListOfHelpingStates;
import newGITmetamodelwithtypesnosections.ListOfRelocatedTransition;
import newGITmetamodelwithtypesnosections.ListOfVariables;
import newGITmetamodelwithtypesnosections.NewGITmetamodelwithtypesnosectionsPackage;
import newGITmetamodelwithtypesnosections.State;
import newGITmetamodelwithtypesnosections.StateMachine;
import newGITmetamodelwithtypesnosections.Transition;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>State Machine</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link newGITmetamodelwithtypesnosections.impl.StateMachineImpl#getName <em>Name</em>}</li>
 *   <li>{@link newGITmetamodelwithtypesnosections.impl.StateMachineImpl#getInitialState <em>Initial State</em>}</li>
 *   <li>{@link newGITmetamodelwithtypesnosections.impl.StateMachineImpl#getStates <em>States</em>}</li>
 *   <li>{@link newGITmetamodelwithtypesnosections.impl.StateMachineImpl#getTransitions <em>Transitions</em>}</li>
 *   <li>{@link newGITmetamodelwithtypesnosections.impl.StateMachineImpl#getLocalVariables <em>Local Variables</em>}</li>
 *   <li>{@link newGITmetamodelwithtypesnosections.impl.StateMachineImpl#getBooleanLocalVariables <em>Boolean Local Variables</em>}</li>
 *   <li>{@link newGITmetamodelwithtypesnosections.impl.StateMachineImpl#getHelpingStates <em>Helping States</em>}</li>
 *   <li>{@link newGITmetamodelwithtypesnosections.impl.StateMachineImpl#getHelpingclonedForOnExitStates <em>Helpingcloned For On Exit States</em>}</li>
 *   <li>{@link newGITmetamodelwithtypesnosections.impl.StateMachineImpl#getRellocatedTransitions <em>Rellocated Transitions</em>}</li>
 * </ul>
 *
 * @generated
 */
public class StateMachineImpl extends MinimalEObjectImpl.Container implements StateMachine {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getInitialState() <em>Initial State</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitialState()
	 * @generated
	 * @ordered
	 */
	protected InitialState initialState;

	/**
	 * The cached value of the '{@link #getStates() <em>States</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStates()
	 * @generated
	 * @ordered
	 */
	protected EList<State> states;

	/**
	 * The cached value of the '{@link #getTransitions() <em>Transitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTransitions()
	 * @generated
	 * @ordered
	 */
	protected EList<Transition> transitions;

	/**
	 * The cached value of the '{@link #getLocalVariables() <em>Local Variables</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLocalVariables()
	 * @generated
	 * @ordered
	 */
	protected ListOfVariables localVariables;

	/**
	 * The cached value of the '{@link #getBooleanLocalVariables() <em>Boolean Local Variables</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBooleanLocalVariables()
	 * @generated
	 * @ordered
	 */
	protected ListOfBooleanVariables booleanLocalVariables;

	/**
	 * The cached value of the '{@link #getHelpingStates() <em>Helping States</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHelpingStates()
	 * @generated
	 * @ordered
	 */
	protected ListOfHelpingStates helpingStates;

	/**
	 * The cached value of the '{@link #getHelpingclonedForOnExitStates() <em>Helpingcloned For On Exit States</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHelpingclonedForOnExitStates()
	 * @generated
	 * @ordered
	 */
	protected ListOfClonedHelpingStates helpingclonedForOnExitStates;

	/**
	 * The cached value of the '{@link #getRellocatedTransitions() <em>Rellocated Transitions</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRellocatedTransitions()
	 * @generated
	 * @ordered
	 */
	protected ListOfRelocatedTransition rellocatedTransitions;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StateMachineImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return NewGITmetamodelwithtypesnosectionsPackage.Literals.STATE_MACHINE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public InitialState getInitialState() {
		return initialState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInitialState(InitialState newInitialState, NotificationChain msgs) {
		InitialState oldInitialState = initialState;
		initialState = newInitialState;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__INITIAL_STATE, oldInitialState, newInitialState);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInitialState(InitialState newInitialState) {
		if (newInitialState != initialState) {
			NotificationChain msgs = null;
			if (initialState != null)
				msgs = ((InternalEObject)initialState).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__INITIAL_STATE, null, msgs);
			if (newInitialState != null)
				msgs = ((InternalEObject)newInitialState).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__INITIAL_STATE, null, msgs);
			msgs = basicSetInitialState(newInitialState, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__INITIAL_STATE, newInitialState, newInitialState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<State> getStates() {
		if (states == null) {
			states = new EObjectContainmentEList<State>(State.class, this, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__STATES);
		}
		return states;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Transition> getTransitions() {
		if (transitions == null) {
			transitions = new EObjectContainmentEList<Transition>(Transition.class, this, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__TRANSITIONS);
		}
		return transitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfVariables getLocalVariables() {
		return localVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLocalVariables(ListOfVariables newLocalVariables, NotificationChain msgs) {
		ListOfVariables oldLocalVariables = localVariables;
		localVariables = newLocalVariables;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__LOCAL_VARIABLES, oldLocalVariables, newLocalVariables);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setLocalVariables(ListOfVariables newLocalVariables) {
		if (newLocalVariables != localVariables) {
			NotificationChain msgs = null;
			if (localVariables != null)
				msgs = ((InternalEObject)localVariables).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__LOCAL_VARIABLES, null, msgs);
			if (newLocalVariables != null)
				msgs = ((InternalEObject)newLocalVariables).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__LOCAL_VARIABLES, null, msgs);
			msgs = basicSetLocalVariables(newLocalVariables, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__LOCAL_VARIABLES, newLocalVariables, newLocalVariables));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfBooleanVariables getBooleanLocalVariables() {
		return booleanLocalVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBooleanLocalVariables(ListOfBooleanVariables newBooleanLocalVariables, NotificationChain msgs) {
		ListOfBooleanVariables oldBooleanLocalVariables = booleanLocalVariables;
		booleanLocalVariables = newBooleanLocalVariables;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__BOOLEAN_LOCAL_VARIABLES, oldBooleanLocalVariables, newBooleanLocalVariables);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBooleanLocalVariables(ListOfBooleanVariables newBooleanLocalVariables) {
		if (newBooleanLocalVariables != booleanLocalVariables) {
			NotificationChain msgs = null;
			if (booleanLocalVariables != null)
				msgs = ((InternalEObject)booleanLocalVariables).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__BOOLEAN_LOCAL_VARIABLES, null, msgs);
			if (newBooleanLocalVariables != null)
				msgs = ((InternalEObject)newBooleanLocalVariables).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__BOOLEAN_LOCAL_VARIABLES, null, msgs);
			msgs = basicSetBooleanLocalVariables(newBooleanLocalVariables, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__BOOLEAN_LOCAL_VARIABLES, newBooleanLocalVariables, newBooleanLocalVariables));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfHelpingStates getHelpingStates() {
		return helpingStates;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetHelpingStates(ListOfHelpingStates newHelpingStates, NotificationChain msgs) {
		ListOfHelpingStates oldHelpingStates = helpingStates;
		helpingStates = newHelpingStates;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPING_STATES, oldHelpingStates, newHelpingStates);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setHelpingStates(ListOfHelpingStates newHelpingStates) {
		if (newHelpingStates != helpingStates) {
			NotificationChain msgs = null;
			if (helpingStates != null)
				msgs = ((InternalEObject)helpingStates).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPING_STATES, null, msgs);
			if (newHelpingStates != null)
				msgs = ((InternalEObject)newHelpingStates).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPING_STATES, null, msgs);
			msgs = basicSetHelpingStates(newHelpingStates, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPING_STATES, newHelpingStates, newHelpingStates));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfClonedHelpingStates getHelpingclonedForOnExitStates() {
		return helpingclonedForOnExitStates;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetHelpingclonedForOnExitStates(ListOfClonedHelpingStates newHelpingclonedForOnExitStates, NotificationChain msgs) {
		ListOfClonedHelpingStates oldHelpingclonedForOnExitStates = helpingclonedForOnExitStates;
		helpingclonedForOnExitStates = newHelpingclonedForOnExitStates;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPINGCLONED_FOR_ON_EXIT_STATES, oldHelpingclonedForOnExitStates, newHelpingclonedForOnExitStates);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setHelpingclonedForOnExitStates(ListOfClonedHelpingStates newHelpingclonedForOnExitStates) {
		if (newHelpingclonedForOnExitStates != helpingclonedForOnExitStates) {
			NotificationChain msgs = null;
			if (helpingclonedForOnExitStates != null)
				msgs = ((InternalEObject)helpingclonedForOnExitStates).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPINGCLONED_FOR_ON_EXIT_STATES, null, msgs);
			if (newHelpingclonedForOnExitStates != null)
				msgs = ((InternalEObject)newHelpingclonedForOnExitStates).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPINGCLONED_FOR_ON_EXIT_STATES, null, msgs);
			msgs = basicSetHelpingclonedForOnExitStates(newHelpingclonedForOnExitStates, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPINGCLONED_FOR_ON_EXIT_STATES, newHelpingclonedForOnExitStates, newHelpingclonedForOnExitStates));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ListOfRelocatedTransition getRellocatedTransitions() {
		return rellocatedTransitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRellocatedTransitions(ListOfRelocatedTransition newRellocatedTransitions, NotificationChain msgs) {
		ListOfRelocatedTransition oldRellocatedTransitions = rellocatedTransitions;
		rellocatedTransitions = newRellocatedTransitions;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__RELLOCATED_TRANSITIONS, oldRellocatedTransitions, newRellocatedTransitions);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setRellocatedTransitions(ListOfRelocatedTransition newRellocatedTransitions) {
		if (newRellocatedTransitions != rellocatedTransitions) {
			NotificationChain msgs = null;
			if (rellocatedTransitions != null)
				msgs = ((InternalEObject)rellocatedTransitions).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__RELLOCATED_TRANSITIONS, null, msgs);
			if (newRellocatedTransitions != null)
				msgs = ((InternalEObject)newRellocatedTransitions).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__RELLOCATED_TRANSITIONS, null, msgs);
			msgs = basicSetRellocatedTransitions(newRellocatedTransitions, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__RELLOCATED_TRANSITIONS, newRellocatedTransitions, newRellocatedTransitions));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__INITIAL_STATE:
				return basicSetInitialState(null, msgs);
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__STATES:
				return ((InternalEList<?>)getStates()).basicRemove(otherEnd, msgs);
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__TRANSITIONS:
				return ((InternalEList<?>)getTransitions()).basicRemove(otherEnd, msgs);
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__LOCAL_VARIABLES:
				return basicSetLocalVariables(null, msgs);
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__BOOLEAN_LOCAL_VARIABLES:
				return basicSetBooleanLocalVariables(null, msgs);
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPING_STATES:
				return basicSetHelpingStates(null, msgs);
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPINGCLONED_FOR_ON_EXIT_STATES:
				return basicSetHelpingclonedForOnExitStates(null, msgs);
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__RELLOCATED_TRANSITIONS:
				return basicSetRellocatedTransitions(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__NAME:
				return getName();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__INITIAL_STATE:
				return getInitialState();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__STATES:
				return getStates();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__TRANSITIONS:
				return getTransitions();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__LOCAL_VARIABLES:
				return getLocalVariables();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__BOOLEAN_LOCAL_VARIABLES:
				return getBooleanLocalVariables();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPING_STATES:
				return getHelpingStates();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPINGCLONED_FOR_ON_EXIT_STATES:
				return getHelpingclonedForOnExitStates();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__RELLOCATED_TRANSITIONS:
				return getRellocatedTransitions();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__NAME:
				setName((String)newValue);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__INITIAL_STATE:
				setInitialState((InitialState)newValue);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__STATES:
				getStates().clear();
				getStates().addAll((Collection<? extends State>)newValue);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__TRANSITIONS:
				getTransitions().clear();
				getTransitions().addAll((Collection<? extends Transition>)newValue);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__LOCAL_VARIABLES:
				setLocalVariables((ListOfVariables)newValue);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__BOOLEAN_LOCAL_VARIABLES:
				setBooleanLocalVariables((ListOfBooleanVariables)newValue);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPING_STATES:
				setHelpingStates((ListOfHelpingStates)newValue);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPINGCLONED_FOR_ON_EXIT_STATES:
				setHelpingclonedForOnExitStates((ListOfClonedHelpingStates)newValue);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__RELLOCATED_TRANSITIONS:
				setRellocatedTransitions((ListOfRelocatedTransition)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__INITIAL_STATE:
				setInitialState((InitialState)null);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__STATES:
				getStates().clear();
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__TRANSITIONS:
				getTransitions().clear();
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__LOCAL_VARIABLES:
				setLocalVariables((ListOfVariables)null);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__BOOLEAN_LOCAL_VARIABLES:
				setBooleanLocalVariables((ListOfBooleanVariables)null);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPING_STATES:
				setHelpingStates((ListOfHelpingStates)null);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPINGCLONED_FOR_ON_EXIT_STATES:
				setHelpingclonedForOnExitStates((ListOfClonedHelpingStates)null);
				return;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__RELLOCATED_TRANSITIONS:
				setRellocatedTransitions((ListOfRelocatedTransition)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__INITIAL_STATE:
				return initialState != null;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__STATES:
				return states != null && !states.isEmpty();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__TRANSITIONS:
				return transitions != null && !transitions.isEmpty();
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__LOCAL_VARIABLES:
				return localVariables != null;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__BOOLEAN_LOCAL_VARIABLES:
				return booleanLocalVariables != null;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPING_STATES:
				return helpingStates != null;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__HELPINGCLONED_FOR_ON_EXIT_STATES:
				return helpingclonedForOnExitStates != null;
			case NewGITmetamodelwithtypesnosectionsPackage.STATE_MACHINE__RELLOCATED_TRANSITIONS:
				return rellocatedTransitions != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //StateMachineImpl
